Imports System.Data.SqlClient

Public Class frmCustomers
    Inherits System.Windows.Forms.Form

    Protected dsCustomers As DataSet

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents btnPopulate As System.Windows.Forms.Button
    Friend WithEvents lstCustomers As System.Windows.Forms.ListBox
    Friend WithEvents lstOrders As System.Windows.Forms.ListBox
    Friend WithEvents lblStatus As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.btnPopulate = New System.Windows.Forms.Button()
        Me.lstCustomers = New System.Windows.Forms.ListBox()
        Me.lstOrders = New System.Windows.Forms.ListBox()
        Me.lblStatus = New System.Windows.Forms.Label()
        Me.SuspendLayout()
        '
        'btnPopulate
        '
        Me.btnPopulate.Location = New System.Drawing.Point(8, 8)
        Me.btnPopulate.Name = "btnPopulate"
        Me.btnPopulate.Size = New System.Drawing.Size(75, 32)
        Me.btnPopulate.TabIndex = 0
        Me.btnPopulate.Text = "Populate DataSet"
        '
        'lstCustomers
        '
        Me.lstCustomers.Location = New System.Drawing.Point(88, 8)
        Me.lstCustomers.Name = "lstCustomers"
        Me.lstCustomers.Size = New System.Drawing.Size(232, 238)
        Me.lstCustomers.TabIndex = 1
        '
        'lstOrders
        '
        Me.lstOrders.Location = New System.Drawing.Point(328, 8)
        Me.lstOrders.Name = "lstOrders"
        Me.lstOrders.Size = New System.Drawing.Size(392, 238)
        Me.lstOrders.TabIndex = 2
        '
        'lblStatus
        '
        Me.lblStatus.Location = New System.Drawing.Point(8, 48)
        Me.lblStatus.Name = "lblStatus"
        Me.lblStatus.Size = New System.Drawing.Size(72, 40)
        Me.lblStatus.TabIndex = 3
        Me.lblStatus.Text = "Status"
        '
        'frmCustomers
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(728, 266)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.lblStatus, Me.lstOrders, Me.lstCustomers, Me.btnPopulate})
        Me.Name = "frmCustomers"
        Me.Text = "Customers"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub btnPopulate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPopulate.Click
        lblStatus.Text = "Please wait..."

        lstCustomers.Items.Clear()
        lstOrders.Items.Clear()

        Dim cnNWind As New SqlConnection( _
            "Integrated Security=SSPI;Initial Catalog=Northwind;" & _
            "Data Source=(local)")
        Dim daCustomers As New SqlDataAdapter( _
            "SELECT CustomerID, CompanyName FROM Customers", _
            cnNWind)
        Dim daOrders As New SqlDataAdapter( _
            "SELECT OrderID, OrderDate, CustomerID, EmployeeID FROM Orders", _
            cnNWind)
        Dim daEmployees As New SqlDataAdapter( _
            "SELECT EmployeeID, LastName, FirstName FROM Employees", _
            cnNWind)

        dsCustomers = New DataSet("Customers")

        daCustomers.Fill(dsCustomers, "Customers")
        Dim dtCustomers As DataTable = dsCustomers.Tables("Customers")
        daOrders.Fill(dsCustomers, "Orders")
        Dim dtOrders As DataTable = dsCustomers.Tables("Orders")
        daEmployees.Fill(dsCustomers, "Employees")

        dsCustomers.Relations.Add("CustomerOrders", _
            New DataColumn() {dtCustomers.Columns("CustomerID")}, _
            New DataColumn() {dtOrders.Columns("CustomerID")})

        Dim dr As DataRow
        For Each dr In dtCustomers.Rows
            lstCustomers.Items.Add(dr.Item("CustomerID").ToString() & _
                " --- " & dr.Item("CompanyName").ToString())
        Next

        lblStatus.Text = "Data Retrieved"
    End Sub

    Private Sub lstCustomers_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles lstCustomers.SelectedIndexChanged
        lstOrders.Items.Clear()

        Dim parentRow As DataRow = dsCustomers.Tables("Customers").Select( _
           "CustomerID = '" & lstCustomers.SelectedItem.ToString().Substring(0, 5) & _
           "'")(0)
        Dim childRows() As DataRow = parentRow.GetChildRows( _
            dsCustomers.Relations("CustomerOrders"))
        Dim dr As DataRow
        For Each dr In childRows
            Dim drEmp As DataRow = dsCustomers.Tables("Employees").Select( _
                "EmployeeID = '" & dr.Item("EmployeeID").ToString() & "'")(0)
            lstOrders.Items.Add(dr.Item("OrderID").ToString() & " - " & _
                dr.Item("OrderDate").ToLongDateString() & " - " & _
                drEmp.Item("FirstName").ToString() & " " & _
                drEmp.Item("LastName").ToString())
        Next
    End Sub
End Class
